## yices2-2.6.5.gh.tar.gz

=== Makefile ===
#########################################################################
#
#  This file is part of the Yices SMT Solver.
#  Copyright (C) 2017 SRI International.
#
#  Yices is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  Yices is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with Yices.  If not, see <http://www.gnu.org/licenses/>.
#
#########################################################################

#
# Top-level Makefile
#
# Determine the architecture and top directory.
# Import architecture files from top-dir/configs/make.include.$(ARCH)
#

SHELL=/bin/sh

YICES_TOP_DIR=$(shell pwd)

#
# Version numbers: <version>.<minor>.<patch-level>
# - this determines the name of the distribution tarfile
# - the number is also used in the shared library
#   for linux:  the soname is libyices.so.<major>.<minor>
#   for darwin: the compatibility version is <major>.<minor>.0
#               the version is set to <major>.<minor>.<patch-level>
#
# Conventions we should follow:
# <major> increases for major new releases.
# <minor> increases when we make changes that loose
#         backward compatibility.
# <patch-level> increases for bug fixes or other improvements
#         that maintain backward compatibility.
#
# Example: if P is linked against libyices.so version 2.0.0
# - P should still work (without recompliling) with libyices 2.0.1
# - P should not work anymore with libyices 2.1.0 or 3.0.0
#
# N.B There are also an occurrences in:
# src/include/yices.h
# doc/manual/manual.tex
# doc/sphinx/source/conf.py
# doc/yices*.1 man files
#
MAJOR = 2
MINOR = 6
PATCH_LEVEL = 5

YICES_VERSION = $(MAJOR).$(MINOR).$(PATCH_LEVEL)


#
# Find platform (also default configuration)
#
ARCH=$(shell ./config.sub `./config.guess`)
POSIXOS=$(shell ./autoconf/os)
PLATFORM=$(shell uname -p)

ifeq (,$(POSIXOS))
  $(error "Problem running ./autoconf/os")
else
ifeq (unknown,$(POSIXOS))
  $(error "Unknown OS")
endif
endif


#
# OPTION: select an alternative configuration file
#
# 1) On Mac OS X Leopard/intel (darwin9.X.Y), the default configuration is
#    in file  make.include.i386-apple-darwin9.X.Y
#    This builds Yices as a 32bit executable.
#
#    It's possible to use an alternative configuration file
#       make.include.x86_64-apple-darwin9.Y.Z on the same system.
#    This is intended to build Yices as 64bit code.
#
#    To select the alternative configuration use 'make OPTION=64bits ..'
#
# 1a) Since Mac OS X Snow Leopard (darwin10.X.Y) and newer, the default
#     is reversed. The default configuration is in file
#        make.include.x86_64-apple-darwin10.X.Y
#     This builds Yices for 64bit by default.
#
#     To build for 32bit on the same system, use the alternative
#     configuration file  make.include.i386-apple-darwin10.X.Y
#
#     To select the alternative configuration use 'make OPTION=32bits ...'
#
# 2) On Linux/x86_64, we compile in 64 bit mode by default,
#    using configuration file make.include.x86_64-unknown-linux-gnu
#
#    It may be possible to build in 32 bit mode on the same machine,
#    provided the compiler understand option -m32 and the necessary
#    32bit libraries are present. The corresponding Yices configuration
#    is make.include.i686-unknown-linux-gnu
#
#    To select this 32bit configuration, use 'make OPTION=32bits ...'
#
# 3) On cygwin, the default configuration is make.include.i686-pc-cygwin.
#    Two alternatives are supported:
#         make.include.i686-pc-mingw32    (mingw32/Windows 32bit native)
#    and  make.include.x86_64-pc-mingw32  (Windows 64bit native)
#
#    To select the Windows 32bit configuration, use
#          'make OPTION=no-cygwin ...'
#       or 'make OPTION=mingw32 ...'
#
#    To select the Windows 64bit configuration, use
#         'make OPTION=mingw64'
#
#    Issue: 2013/12/11: this Makefile is not robust for
#    cross-compilation on Cygwin (to produce Windows 64 code).
#    The simplest way to configure for this cross-compilation is
#       ./configure --host=x86_64-w64-mingw32 ....
#
#    This generates ./configs/makefile.include.x86_64-w64-mingw32.
#    But OPTION=mingw64 gives ./configs/makefile.include.x86_64-pc-mingw32
#
#
# 4) On solaris, the default is make.include.sparc-sun-solaris2.x
#    (should be 32bits).
#
#    The alternative is make.include.sparc64-sun-solaris2.x
#    (should be for 64bits build). To select it, give OPTION=64bits.
#
# Check README for details on generating these alternative configurations.
#
ifneq ($(OPTION),)
  ifeq ($(POSIXOS),linux)
    ifeq ($(OPTION),32bits)
      newarch=$(subst x86_64,i686,$(ARCH))
    else
    ifeq ($(OPTION),mingw32)
      newarch=i686-w64-mingw32
      POSIXOS=mingw
    endif
    endif
  else
  ifeq ($(POSIXOS),darwin)
    ifeq ($(PLATFORM),powerpc)
      ifeq ($(OPTION),64bits)
        newarch=$(subst powerpc,powerpc64,$(ARCH))
      else
      ifeq ($(OPTION),32bits)
        newarch=$(subst powerpc64,powerpc,$(ARCH))
      endif
      endif
    else
      ifeq ($(OPTION),64bits)
        newarch=$(subst i386,x86_64,$(ARCH))
      else
      ifeq ($(OPTION),32bits)
        newarch=$(subst x86_64,i386,$(ARCH))
      endif
      endif
    endif
  else
  ifeq ($(POSIXOS),cygwin)
    ifeq ($(OPTION),32bits)
      newarch=$(subst x86_64,i686,$(ARCH))
    else
    ifeq ($(OPTION),no-cygwin)
      newarch=$(subst cygwin,mingw32,$(subst x86_64,i686,$(ARCH)))
      alternate=$(subst pc,w64,$(subst unknown,w64,$(newarch)))
      POSIXOS=mingw
    else
    ifeq ($(OPTION),mingw32)
      newarch=$(subst cygwin,mingw32,$(subst x86_64,i686,$(ARCH)))
      alternate=$(subst pc,w64,$(subst unknown,w64,$(newarch)))
      POSIXOS=mingw
    else
    ifeq ($(OPTION),mingw64)
      newarch=$(subst cygwin,mingw32,$(subst i686,x86_64,$(ARCH)))
      alternate=$(subst pc,w64,$(subst unknown,w64,$(newarch)))
      POSIXOS=mingw
    endif
    endif
    endif
    endif
  else
  ifeq ($(POSIXOS),sunos)
    ifeq ($(OPTION),64bits)
      newarch=$(subst sparc,sparc64,$(ARCH))
    endif
  endif
  ifeq ($(POSIXOS),freebsd)
    ifeq ($(OPTION),32bits)
      newarch=$(subst x86_64,i386,$(ARCH))
    endif
  endif
  endif
  endif
  endif

  ifeq ($(newarch),)
    $(error "option $(OPTION) not supported on platform $(ARCH)")
  endif
  ARCH := $(newarch)
endif


#
# Check whether make.include exists
#
# Note: we don't want to run ./configure from here.
# The user may need to give options to the ./configure
# script.
#
make_include = configs/make.include.$(ARCH)
known_make_includes = $(filter-out %.in, $(wildcard configs/make.include.*))

YICES_MAKE_INCLUDE := $(findstring $(make_include), $(known_make_includes))

ifeq (,$(YICES_MAKE_INCLUDE))
  #
  # Try alternate name (--host= ...)
  #
  ifneq (,$(alternate))
     make_alternate = configs/make.include.$(alternate)
     YICES_MAKE_INCLUDE := $(findstring $(make_alternate), $(known_make_includes))
     ifeq (,$(YICES_MAKE_INCLUDE))
        $(error Could not find $(make_include) nor $(make_alternate). Run ./configure)
     else
        $(info Could not find $(make_include). Using $(make_alternate) instead)
     endif
  else
    $(error Could not find $(make_include). Run ./configure)
  endif
endif


#
# Check build mode
#
default_mode=release
allowed_modes=release debug devel profile gcov valgrind purify quantify gperftools sanitize
MODE ?= $(default_mode)

YICES_MODE := $(filter $(allowed_modes), $(MODE))

ifeq (,$(YICES_MODE))
  $(error "Invalid build mode: $(MODE)")
endif


#
# Default target: build binaries/libraries
#
default: dist

#
# Just print the configuration
#
show-config: checkgmake
	@ echo "ARCH is $(ARCH)"
	@ echo "POSIXOS is $(POSIXOS)"
	@ echo "YICES_TOP_DIR is $(YICES_TOP_DIR)"
	@ echo "YICES_MAKE_INCLUDE is $(YICES_MAKE_INCLUDE)"
	@ echo "YICES_MODE is $(YICES_MODE)"
	@ echo "YICES_VERSION is $(YICES_VERSION)"

checkgmake:
	@ ./gmaketest --make=$(MAKE) || \
	  (echo "GNU-Make is required to compile Yices. Aborting."; exit1)


#
# Invoke submake that will do the real work
# the quotes around the 'YICES_TOP_DIR= ...' help if the directory
# name include spaces
#
# We must have doc as an explicit target since we have a ./doc directory.
# Without it 'make doc' does nothing. To be safe, I've also added bin,
# lib, obj, etc. so that the Makefile will work event if directories
# or files with these names are present.
#
.DEFAULT doc all bin lib obj dist static-bin static-lib static-obj static-dist install test static-test \
   check static-check check-api static-check-api: checkgmake
	@ echo "Mode:     $(YICES_MODE)"
	@ echo "Platform: $(ARCH)"
	@ $(MAKE) -f Makefile.build \
	'YICES_MODE=$(YICES_MODE)' \
	'ARCH=$(ARCH)' \
	'POSIXOS=$(POSIXOS)' \
	'YICES_TOP_DIR=$(YICES_TOP_DIR)' \
	'YICES_MAKE_INCLUDE=$(YICES_MAKE_INCLUDE)' \
	'YICES_VERSION=$(YICES_VERSION)' \
	'MAJOR=$(MAJOR)' \
	'MINOR=$(MINOR)' \
	'PATCH_LEVEL=$(PATCH_LEVEL)' \
	$@


.PHONY: checkgmake show-config doc all bin lib obj dist static-bin static-lib static-obj static-dist install \
        test static-test default check static-check check-api static-check-api

=== src/Makefile ===
#########################################################################
#
#  This file is part of the Yices SMT Solver.
#  Copyright (C) 2017 SRI International.
#
#  Yices is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  Yices is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with Yices.  If not, see <http://www.gnu.org/licenses/>.
#
#########################################################################

#
# src/Makefile
#
# Must be invoked with the following variables set
#
#   YICES_TOP_DIR = top-level directory for Yices
#   YICES_MODE = build mode
#   YICES_MAKE_INCLUDE = configuration file to include
#   YICES_VERSION = full version
#   MAJOR = major version number
#   MINOR = minor version number
#   PATCH_LEVEL = patch level
#   ARCH = architecture (e.g, i686-pc-linux-gnu)
#   POSIXOS = OS (e.g., linux)
#   BUILD = target build director (normally build/$(ARCH)-$(YICES_MODE))
#
# Config variables are imported by including the file
#   $(YICES_TOP_DIR)/$(YICES_MAKE_INCLUDE)
#

SHELL=/bin/sh

ifeq (,$(YICES_TOP_DIR))
 $(error "YICES_TOP_DIR is undefined")
endif

ifeq (,$(YICES_MAKE_INCLUDE))
 $(error "YICES_MAKE_INCLUDE is undefined")
endif

conf=$(YICES_TOP_DIR)/$(YICES_MAKE_INCLUDE)

include $(conf)

#
# Build subdirectories
# --------------------
# build/obj: object files, in a form suitable for the dynamic libraries
#	    (e.g., compiled with option -fPIC)
# build/static_obj: object files compiled in a form suitable for libyices.a
#	    (e.g., compiled without -fPIC)
#
# build/lib: libraries (GMP not included)
# build/bin: binaries (GMP not included)
#
# build/static_lib: libraries (GMP included)
# build/static_bin: binaries linked statically with GMP (and other libraries if possible)
#
# For cygiwn and mingw: we use a third subdirectory to build objects for the
# dll that includes libgmp.a
# build/static_dll_obj
#
objdir := $(BUILD)/obj
libdir := $(BUILD)/lib
bindir := $(BUILD)/bin

static_objdir := $(BUILD)/static_obj
static_libdir := $(BUILD)/static_lib
static_bindir := $(BUILD)/static_bin

static_dll_objdir := $(BUILD)/static_dll_obj

#
# Distribution subdirectory: tarfiles are constructed
# via make binary-distribution or make smt-distribution
#
# In this makefile, we just copy what needs to be included
# in the distribution tarfiles in $(BUILD)/dist or $(BUILD)/static_dist
#
distdir := $(BUILD)/dist
static_distdir := $(BUILD)/static_dist
smt_distdir := $(BUILD)/smt_dist
static_smt_distdir := $(BUILD)/static_smt_dist



#
# SOURCE FILES
#

#
# Source files for the dynamic library (libyices.so)
#
core_src_c := \
	api/context_config.c \
	api/search_parameters.c \
	api/smt_logic_codes.c \
	api/yices_api.c \
	api/yices_error.c \
	api/yices_error_report.c \
	api/yval.c \
	context/assumption_stack.c \
	context/common_conjuncts.c \
	context/conditional_definitions.c \
	context/context.c \
	context/context_simplifier.c \
	context/context_solver.c \
	context/context_statistics.c \
	context/context_utils.c \
	context/divmod_table.c \
	context/eq_abstraction.c \
	context/eq_learner.c \
	context/internalization_table.c \
	context/ite_flattener.c \
	context/pseudo_subst.c \
	context/shared_terms.c \
	context/symmetry_breaking.c \
	context/quant_context_utils.c \
	context/quant_context.c \
	exists_forall/ef_client.c \
	exists_forall/ef_analyze.c \
	exists_forall/ef_values.c \
	exists_forall/ef_skolemize.c \
	exists_forall/efsolver.c \
	frontend/smt2/attribute_values.c \
	frontend/yices/yices_lexer.c \
	frontend/yices/yices_parser.c \
	io/concrete_value_printer.c \
	io/model_printer.c \
	io/pretty_printer.c \
	io/reader.c \
	io/simple_printf.c \
	io/term_printer.c \
	io/tracer.c \
	io/type_printer.c \
	io/yices_pp.c \
	io/writer.c \
	model/abstract_values.c \
	model/arith_projection.c \
	model/concrete_values.c \
	model/fresh_value_maker.c \
	model/fun_maps.c \
	model/fun_trees.c \
	model/generalization.c \
	model/literal_collector.c \
	model/map_to_model.c \
	model/model_eval.c \
	model/model_queries.c \
	model/model_support.c \
	model/models.c \
	model/presburger.c \
	model/projection.c \
	model/term_to_val.c \
	model/val_to_term.c \
	mt/yices_locks.c \
	parser_utils/lexer.c \
	parser_utils/parser.c \
	parser_utils/term_stack2.c \
	parser_utils/term_stack_error.c \
	solvers/bv/bit_blaster.c \
	solvers/bv/bv64_intervals.c \
	solvers/bv/bv_atomtable.c \
	solvers/bv/bvconst_hmap.c \
	solvers/bv/bvexp_table.c \
	solvers/bv/bv_intervals.c \
	solvers/bv/bvpoly_compiler.c \
	solvers/bv/bvpoly_dag.c \
	solvers/bv/bvsolver.c \
	solvers/bv/bv_vartable.c \
	solvers/bv/dimacs_printer.c \
	solvers/bv/merge_table.c \
	solvers/bv/remap_table.c \
	solvers/cdcl/delegate.c \
	solvers/cdcl/gates_hash_table.c \
	solvers/cdcl/gates_manager.c \
	solvers/cdcl/new_gates.c \
	solvers/cdcl/new_gate_hash_map.c \
	solvers/cdcl/new_gate_hash_map2.c \
	solvers/cdcl/new_sat_solver.c \
	solvers/cdcl/smt_core.c \
	solvers/cdcl/truth_tables.c \
	solvers/cdcl/wide_truth_tables.c \
	solvers/egraph/composites.c \
	solvers/egraph/diseq_stacks.c \
	solvers/egraph/egraph_assertion_queues.c \
	solvers/egraph/egraph.c \
	solvers/egraph/egraph_explanations.c \
	solvers/egraph/egraph_utils.c \
	solvers/egraph/theory_explanations.c \
	solvers/floyd_warshall/dl_vartable.c \
	solvers/floyd_warshall/idl_floyd_warshall.c \
	solvers/floyd_warshall/rdl_floyd_warshall.c \
	solvers/funs/fun_level.c \
	solvers/funs/fun_solver.c \
	solvers/funs/stratification.c \
	solvers/simplex/arith_atomtable.c \
	solvers/simplex/arith_vartable.c \
	solvers/simplex/diophantine_systems.c \
	solvers/simplex/gomory_cuts.c \
	solvers/simplex/integrality_constraints.c \
	solvers/simplex/matrices.c \
	solvers/simplex/offset_equalities.c \
	solvers/simplex/simplex.c \
	solvers/quant/quant_parameters.c \
	solvers/quant/ef_parameters.c \
	solvers/quant/ef_problem.c \
	solvers/quant/quant_pattern.c \
	solvers/quant/quant_cnstr.c \
	solvers/quant/cnstr_learner.c \
	solvers/quant/term_learner.c \
	solvers/quant/ematch_instr.c \
	solvers/quant/ematch_instr_stack.c \
	solvers/quant/ematch_instance.c \
	solvers/quant/ematch_compile.c \
	solvers/quant/ematch_execute.c \
	solvers/quant/quant_ematching.c \
	solvers/quant/quant_solver.c \
	terms/balanced_arith_buffers.c \
	terms/bit_expr.c \
	terms/bit_term_conversion.c \
	terms/bv64_interval_abstraction.c \
	terms/bv64_constants.c \
	terms/bv64_polynomials.c \
	terms/bvarith64_buffers.c \
	terms/bvarith64_buffer_terms.c \
	terms/bvarith_buffers.c \
	terms/bvarith_buffer_terms.c \
	terms/bv_constants.c \
	terms/bvfactor_buffers.c \
	terms/bvlogic_buffers.c \
	terms/bvpoly_buffers.c \
	terms/bv_polynomials.c \
	terms/bv_slices.c \
	terms/conditionals.c \
	terms/elim_subst.c \
	terms/extended_rationals.c \
	terms/free_var_collector.c \
	terms/full_subst.c \
	terms/int_rational_hash_maps.c \
	terms/ite_stack.c \
	terms/mpq_aux.c \
	terms/mpq_stores.c \
	terms/poly_buffer.c \
	terms/poly_buffer_terms.c \
	terms/polynomials.c \
	terms/power_products.c \
	terms/pprod_table.c \
	terms/rational_hash_maps.c \
	terms/rationals.c \
	terms/rba_buffer_terms.c \
	terms/renaming_context.c \
	terms/subst_cache.c \
	terms/subst_context.c \
	terms/term_explorer.c \
	terms/term_manager.c \
	terms/terms.c \
	terms/term_sets.c \
	terms/term_substitution.c \
	terms/term_utils.c \
	terms/types.c \
	terms/variable_renaming.c \
	utils/arena.c \
	utils/backtrack_arrays.c \
	utils/backtrack_int_hash_map.c \
	utils/cache.c \
	utils/csets.c \
	utils/cputime.c \
	utils/dep_tables.c \
	utils/error.c \
	utils/gcd.c \
	utils/generic_heap.c \
	utils/hash_functions.c \
	utils/index_vectors.c \
	utils/indexed_table.c \
	utils/int_array_hsets.c \
	utils/int_array_sort2.c \
	utils/int_array_sort.c \
	utils/int_bags.c \
	utils/int_bv_sets.c \
	utils/int_harray_store.c \
	utils/int_hash_classes.c \
	utils/int_hash_map2.c \
	utils/int_hash_map.c \
	utils/int_hash_sets.c \
	utils/int_hash_tables.c \
	utils/int_heap2.c \
	utils/int_heap.c \
	utils/int_partitions.c \
	utils/int_powers.c \
	utils/int_queues.c \
	utils/int_stack.c \
	utils/int_vectors.c \
	utils/mark_vectors.c \
	utils/memalloc.c \
	utils/object_stack.c \
	utils/object_stores.c \
	utils/pair_hash_map.c \
	utils/pair_hash_map2.c \
	utils/pointer_vectors.c \
	utils/ptr_array_sort2.c \
	utils/ptr_array_sort.c \
	utils/ptr_hash_classes.c \
	utils/ptr_hash_map.c \
	utils/ptr_heap.c \
	utils/ptr_partitions.c \
	utils/ptr_queues.c \
	utils/ptr_sets.c \
	utils/ptr_sets2.c \
	utils/ptr_stack.c \
	utils/ptr_vectors.c \
	utils/refcount_int_arrays.c \
	utils/refcount_strings.c \
	utils/resize_arrays.c \
	utils/simple_cache.c \
	utils/simple_int_stack.c \
	utils/sparse_arrays.c \
	utils/stable_sort.c \
	utils/string_buffers.c \
	utils/string_utils.c \
	utils/symbol_tables.c \
	utils/tag_map.c \
	utils/tuple_hash_map.c \
	utils/uint_array_sort.c \
	utils/uint_array_sort2.c \
	utils/uint_rbtrees.c \
	utils/use_vectors.c \
	utils/vector_hash_map.c \
	utils/uint_learner.c

#
# Optional: mcsat solver
#
mcsat_src_c := \
	mcsat/tracing.c \
	mcsat/solver.c \
	mcsat/variable_db.c \
	mcsat/variable_queue.c \
	mcsat/value.c \
	mcsat/model.c \
	mcsat/trail.c \
	mcsat/conflict.c \
	mcsat/gc.c \
	mcsat/eq/equality_graph.c \
	mcsat/eq/merge_queue.c \
	mcsat/weq/weak_eq_graph.c \
	mcsat/utils/int_mset.c \
	mcsat/utils/int_lset.c \
	mcsat/utils/value_hash_map.c \
	mcsat/utils/value_vector.c \
	mcsat/utils/scope_holder.c \
	mcsat/utils/statistics.c \
	mcsat/utils/substitution.c \
	mcsat/uf/uf_plugin.c \
	mcsat/bool/clause_db.c \
	mcsat/bool/cnf.c \
	mcsat/bool/bcp_watch_manager.c \
	mcsat/bool/bool_plugin.c \
	mcsat/nra/nra_plugin.c \
	mcsat/nra/nra_plugin_internal.c \
	mcsat/nra/nra_plugin_explain.c \
	mcsat/nra/libpoly_utils.c \
	mcsat/nra/poly_constraint.c \
	mcsat/nra/feasible_set_db.c \
	mcsat/ite/ite_plugin.c \
	mcsat/bv/bv_plugin.c \
	mcsat/bv/bv_bdd_manager.c \
	mcsat/bv/bv_evaluator.c \
	mcsat/bv/bv_explainer.c \
	mcsat/bv/bv_feasible_set_db.c \
	mcsat/bv/bdd_computation.c \
	mcsat/bv/explain/arith_utils.c \
	mcsat/bv/explain/arith_norm.c \
	mcsat/bv/explain/arith_intervals.c \
	mcsat/bv/explain/arith.c \
	mcsat/bv/explain/eq_ext_con.c \
	mcsat/bv/explain/full_bv_sat.c \
	mcsat/bv/explain/full_bv_trivial.c \
	mcsat/watch_list_manager.c \
	mcsat/preprocessor.c \
	mcsat/options.c



#
# Fake mcsat module: do nothing. Used to make the compilation go through.
#
no_mcsat_src_c := \
	mcsat/no_mcsat.c \
	mcsat/options.c


#
# Other source files for libyices.a
# That's all the code needed by the main binaries
# + experimental/unfinished modules
# + functions for printing/debugging
# + old stuff not needed anymore (except for tests)
#
extra_src_c := \
	context/context_parameters.c \
	context/context_printer.c \
	context/dump_context.c \
	context/internalization_printer.c \
	frontend/common/assumptions_and_core.c \
	frontend/common/assumption_table.c \
	frontend/common/bug_report.c \
	frontend/common/named_term_stacks.c \
	frontend/common/parameters.c \
	frontend/common/tables.c \
	frontend/smt1/smt_lexer.c \
	frontend/smt1/smt_parser.c \
	frontend/smt1/smt_term_stack.c \
	frontend/smt2/parenthesized_expr.c \
	frontend/smt2/smt2_commands.c \
	frontend/smt2/smt2_expressions.c \
	frontend/smt2/smt2_lexer.c \
	frontend/smt2/smt2_model_printer.c \
	frontend/smt2/smt2_parser.c \
	frontend/smt2/smt2_printer.c \
	frontend/smt2/smt2_symbol_printer.c \
	frontend/smt2/smt2_term_stack.c \
	frontend/smt2/smt2_type_printer.c \
	frontend/yices/arith_solver_codes.c \
	frontend/yices/labeled_assertions.c \
	frontend/yices/yices_help.c \
	frontend/yices/yices_reval.c \

=== tests/unit/Makefile ===
#########################################################################
#
#  This file is part of the Yices SMT Solver.
#  Copyright (C) 2017 SRI International.
# 
#  Yices is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
# 
#  Yices is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
# 
#  You should have received a copy of the GNU General Public License
#  along with Yices.  If not, see <http://www.gnu.org/licenses/>.
#
#########################################################################                

#
# tests/unit/Makefile
#
# Must be invoked with the following variables set
#
#   YICES_TOP_DIR = top-level directory for Yices
#   YICES_MODE = build mode
#   YICES_MAKE_INCLUDE = configuration file to include
#   ARCH = architecture (e.g, i686-pc-linux-gnu)
#   POSIXOS = OS (e.g., linux)
#   BUILD = target build director (normally build/$(ARCH)-$(YICES_MODE))
#
# Config variables are imported by including the file
#   $(YICES_TOP_DIR)/$(YICES_MAKE_INCLUDE)
#

SHELL=/bin/sh

ifeq (,$(YICES_TOP_DIR))
 $(error "YICES_TOP_DIR is undefined")
endif

ifeq (,$(YICES_MAKE_INCLUDE))
 $(error "YICES_MAKE_INCLUDE is undefined")
endif

conf=$(YICES_TOP_DIR)/$(YICES_MAKE_INCLUDE)

include $(conf)



#
# build subdirectories
#
objdir := $(BUILD)/obj
libdir := $(BUILD)/lib
bindir := $(BUILD)/bin

static_objdir := $(BUILD)/static_obj
static_libdir := $(BUILD)/static_lib
static_bindir := $(BUILD)/static_bin


#
# All source files in this directory
#
src_c := $(wildcard *.c)

#
# Dependencies and binaries
#
dep := $(src_c:%.c=$(objdir)/%.d)
static_dep := $(src_c:%.c=$(static_objdir)/%.d)

tests := $(src_c:%.c=$(bindir)/%$(EXEEXT))
static_tests := $(src_c:%.c=$(static_bindir)/%$(EXEEXT))

#
# Archives to link with:
# - libyices: objects compiled with the PIC option
# - static_libyices: compiled without the PIC option
#
libyices := $(libdir)/libyices.a
static_libyices := $(static_libdir)/libyices.a

#
# Whether we are building for a big endian architecture
#
ifeq ($(WORDS_BIGENDIAN),yes)
  CPPFLAGS += -DWORDS_BIGENDIAN
endif

#
# Whether we have support for mcsat
#
ifeq ($(ENABLE_MCSAT),yes)
  CPPFLAGS+=-DHAVE_MCSAT
endif

#
# Whether we have thread safety
# If so on Unix systems, we must add -pthread to CFLAGS
#
PTRHEAD=
ifeq ($(THREAD_SAFE),1)
  CPPFLAGS += -DTHREAD_SAFE
  PTHREAD= -pthread
endif


#
# OS-dependent compilation flags
# -fPIC: default on Darwin/Cygwin/Mingw (and causes
#  compilation warning if present)
# -static: not supported by Darwin and our Solaris2.10
# matchine
#
# All tests are linked with libyices.a
# so we don't want any dllimport/export in yices.h
# So we use -DNOYICES_DLL on cygwin and mingw
#
ifeq ($(POSIXOS),cygwin)
  CPPFLAGS := $(CPPFLAGS) -DCYGWIN -DNOYICES_DLL
  PIC=
  STATIC=-static -static-libgcc
  LDFLAGS += -Wl,--stack,8388608
else
ifeq ($(POSIXOS),mingw)
  CPPFLAGS := $(CPPFLAGS) -DMINGW -DNOYICES_DLL -D__USE_MINGW_ANSI_STDIO
  PIC=
  STATIC=-static
  LDFLAGS += -Wl,--stack,8388608
else
ifeq ($(POSIXOS),darwin)
  CPPFLAGS := $(CPPFLAGS) -DMACOSX
  CFLAGS += -fvisibility=hidden $(PTHREAD)
  PIC=-fPIC
  STATIC=
else
ifeq ($(POSIXOS),sunos)
  CPPFLAGS := $(CPPFLAGS) -DSOLARIS
  CFLAGS += -fvisibility=hidden $(PTHREAD)
  PIC=-fPIC
  STATIC=
else
ifeq ($(POSIXOS),linux)
  CPPFLAGS := $(CPPFLAGS) -DLINUX
  CFLAGS += -fvisibility=hidden $(PTHREAD)
  PIC=-fPIC
  STATIC=-static
  LIBS+=$(PTHREAD)
else
ifeq ($(POSIXOS),freebsd)
  CPPFLAGS := $(CPPFLAGS) -DFREEBSD
  CFLAGS += -fvisibility=hidden $(PTHREAD)
  PIC=-fPIC
  STATIC=-static
else
ifeq ($(POSIXOS),netbsd)
  PIC=-fPIC
  STATIC=-static
  CPPFLAGS := $(CPPFLAGS) -DNETBSD
  CFLAGS += -fvisibility=hidden $(PTHREAD)
  BIN_LDFLAGS=
  libyices_dynamic=$(libdir)/$(libyices_so)
  static_libyices_dynamic=$(static_libdir)/$(libyices_so)
else
ifeq ($(POSIXOS),unix)
  PIC=-fPIC
  STATIC=-static
  CPPFLAGS := $(CPPFLAGS) -DLINUX
  CFLAGS += -fvisibility=hidden $(PTHREAD)
  BIN_LDFLAGS=
  libyices_dynamic=$(libdir)/$(libyices_so)
  static_libyices_dynamic=$(static_libdir)/$(libyices_so)
else
 $(error "Don't know how to compile on $(POSIXOS)")
endif
endif
endif
endif
endif
endif
endif
endif



#
# Warning levels: for the unit tests we don't use -Winline
#
CFLAGS += -Wall -Wredundant-decls
ifeq ($(POSIXOS),mingw)
  CFLAGS += -Wno-format
endif


#
# Compilation flags dependent on MODE
#
ifeq ($(YICES_MODE),release)
  CFLAGS := $(CFLAGS) -O3 -fomit-frame-pointer $(NO_STACK_PROTECTOR)
  CPPFLAGS := $(CPPFLAGS) -DNDEBUG
else
ifeq ($(YICES_MODE),devel)
  CFLAGS := $(CFLAGS) -O3 -fomit-frame-pointer $(NO_STACK_PROTECTOR)
  CPPFLAGS := $(CPPFLAGS) -DNDEBUG
else
ifeq ($(YICES_MODE),profile)
  CFLAGS := $(CFLAGS) -O3 -pg
  CPPFLAGS := $(CPPFLAGS) -DNDEBUG
else
ifeq ($(YICES_MODE),gcov)
  CFLAGS := $(CFLAGS) -fprofile-arcs -ftest-coverage
  CPPFLAGS := $(CPPFLAGS) -DNDEBUG
else
ifeq ($(YICES_MODE),sanitize)
CFLAGS := $(CFLAGS) -O3 -g -fsanitize=address,undefined -fno-omit-frame-pointer
CPPFLAGS := $(CPPFLAGS) -DNDEBUG
else
ifeq ($(findstring $(YICES_MODE),valgrind quantify purify),$(YICES_MODE))
  CFLAGS := $(CFLAGS) -O3 -g
  CPPFLAGS := $(CPPFLAGS) -DNDEBUG
else
ifeq ($(YICES_MODE),gperftools)
CFLAGS := $(CFLAGS) -O3 -g
CPPFLAGS := $(CPPFLAGS) -DNDEBUG
ifeq ($(POSIXOS),linux)
  LIBS += -Wl,--no-as-needed -lprofiler
else
  LIBS += -lprofiler
endif
else
#
# debug mode
#
CFLAGS := $(CFLAGS) -g
endif
endif
endif
endif
endif
endif
endif

#
# Link command for purify/quantify
#
ifeq ($(POSIXOS),sunos)
ifeq ($(YICES_MODE),purify)
LNK := purify $(CC)
else
ifeq ($(YICES_MODE),quantify)
LNK := quantify $(CC)
else
LNK := $(CC)
endif
endif
else
# not solaris
LNK := $(CC)
endif


#
# Include path: -I../../src must be first in case there
# are other -I in CPPFLAGS
#
CPPFLAGS := -I../../src -I../../src/include $(CPPFLAGS)


#
# More CPPFLAGS for compiling static objects
#
ifneq ($(STATIC_GMP_INCLUDE_DIR),)
  STATIC_CPP_GMP := -I$(STATIC_GMP_INCLUDE_DIR)
endif

ifneq ($(STATIC_LIBPOLY_INCLUDE_DIR),)
  STATIC_CPP_LIBPOLY := -I$(STATIC_LIBPOLY_INCLUDE_DIR)
endif

STATIC_CPPFLAGS := $(STATIC_CPP_GMP) $(STATIC_CPP_LIBPOLY) $(CPPFLAGS)

#
# These are not needed for the tests -DNOYICES_DLL is already
# in CPPFLAGS
#
# ifeq ($(POSIXOS),cygwin)
#   STATIC_CPPFLAGS += -DNOYICES_DLL
# else
# ifeq ($(POSIXOS),mingw)
#   STATIC_CPPFLAGS += -DNOYICES_DLL
# endif
# endif


#
# LIBS for compiling in static mode
#
# We need to remove -lgmp from LIBS in static mode, otherwise adding
# $(STATIC_GMP) does not work on Darwin and cygwin
#
# Also, we want $(STATIC_GMP) last in this list
#
NOGMP_LIBS := $(subst -lpoly,,$(subst -lgmp,,$(LIBS)))
STATIC_LIBS := $(NOGMP_LIBS) $(STATIC_LIBPOLY) $(STATIC_GMP)


# Dependency file
$(objdir)/%.d: %.c
	@ echo Building dependency file $@
	@ $(CC) -MM $(CPPFLAGS) $< > $@.tmp
	@ $(SED) 's,\($*\).o[ :]*,$(objdir)/\1.o $@ : , g' < $@.tmp > $@
	@ rm -f $@.tmp

$(static_objdir)/%.d: %.c
	@ echo Building dependency file $@
	@ $(CC) -MM $(STATIC_CPPFLAGS) $< > $@.tmp
	@ $(SED) 's,\($*\).o[ :]*,$(static_objdir)/\1.o $@ : , g' < $@.tmp > $@
	@ rm -f $@.tmp

#
# Dependency files
#
$(objdir)/%.d: %.c
	@set -e; echo Building dependency file $@ ; \
	$(CC) -MM -MG -MT $*.o $(CFLAGS) $(CPPFLAGS) $< > $@.$$$$ ; \
	$(SED) 's,\($*\).o[ :]*,$(objdir)/\1.o $@ : , g' < $@.$$$$ > $@ ; \
	rm -f $@.$$$$

$(static_objdir)/%.d: %.c
	@set -e; echo Building dependency file $@ ; \
	$(CC) -MM -MG -MT $*.o $(CFLAGS) $(STATIC_CPPFLAGS) $< > $@.$$$$ ; \
	$(SED) 's,\($*\).o[ :]*,$(static_objdir)/\1.o $@ : , g' < $@.$$$$ > $@ ; \
	rm -f $@.$$$$


static_goals := $(filter %-static,$(MAKECMDGOALS))
dyn_goals := $(filter-out %-static,$(MAKECMDGOALS))

ifneq ($(dyn_goals),)
 include $(dep)
 include $(bin_dep)
 include $(version_dep)
endif

ifneq ($(static_goals),)
 include $(static_dep)
 include $(static_bin_dep)
 include $(static_version_dep)
endif


# Objects
$(objdir)/%.o: %.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $(PIC) -c $< -o $@

$(static_objdir)/%.o: %.c
	$(CC) $(STATIC_CPPFLAGS) $(CFLAGS) -c $< -o $@


# All test binaries, using dynamic GMP library
all: $(tests)

$(bindir)/%$(EXEEXT): $(objdir)/%.o $(libyices)
	$(LNK) $(CFLAGS) $(LDFLAGS) -o $@ $<  $(libyices) $(LIBS)


# Test binaries compiled statically
all-static: $(static_tests)

$(static_bindir)/%$(EXEEXT): $(static_objdir)/%.o $(static_libyices)
	$(LNK) $(CFLAGS) $(LDFLAGS) $(STATIC) -o $@ $<  $(static_libyices) $(STATIC_LIBS)


.PHONY: all all-static


#
# rules to avoid triggering the .DEFAULT rule if .h or .c files have been deleted
#
%.h:
	@ echo
	@ echo "$@ missing"
	@ echo

%.c:
	@ echo
	@ echo "Missing source file: $@"
	@ echo




# For debugging
.DEFAULT:
	@ echo
	@ echo "*** src/Mafefile ***"
	@ echo
	@ echo "target is $@"
	@ echo
	@ echo "ARCH is $(ARCH)"
	@ echo "POSIXOS is $(POSIXOS)"
	@ echo "YICES_TOP_DIR is $(YICES_TOP_DIR)"
	@ echo "YICES_MAKE_INCLUDE is $(YICES_MAKE_INCLUDE)"
	@ echo "YICES_MODE is $(YICES_MODE)"
	@ echo "BUILD is $(BUILD)"
	@ echo
	@ echo "Configuration"
	@ echo "  EXEEXT   = $(EXEEXT)"
	@ echo "  SED      = $(SED)"
	@ echo "  LN_S     = $(LN_S)"
	@ echo "  MKDIR_P  = $(MKDIR_P)"
	@ echo "  CC       = $(CC)"
	@ echo "  CPPFLAGS = $(CPPFLAGS)"
	@ echo "  CFLAGS   = $(CFLAGS)"
	@ echo "  LIBS     = $(LIBS)"
	@ echo "  LDFLAGS  = $(LDFLAGS)"
	@ echo "  LD       = $(LD)"
	@ echo "  AR       = $(AR)"
	@ echo "  RANLIB   = $(RANLIB)"
	@ echo "  STATIC_GMP = $(STATIC_GMP)"
	@ echo "  STATIC_GMP_INCLUDE_DIR = $(STATIC_GMP_INCLUDE_DIR)"
	@ echo

=== debian/changelog ===
yices2 (2.6.2-0ubuntu1) bionic; urgency=medium

  * Initial release. (Closes: #864786)

 -- Ian A. Mason <iam@csl.sri.com>  Thu, 10 Aug 2017 13:46:30 +0000

=== debian/control ===
Source: yices2
Maintainer: Ian A. Mason <iam@csl.sri.com>
Section: misc
Priority: optional
Standards-Version: 3.9.8
Build-Depends: debhelper (>= 9), dh-autoreconf (>= 10), gperf, libgmp-dev, libpoly-dev, cudd, cadical, dh-exec
Homepage: http://yices.csl.sri.com/


Package: libyices2.6
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description:  Yices SMT Solver API Library
 SRI International's Satisfiability Modulo Theory Solver.
 .
 A library to use the Yices API.


Package: yices2
Architecture: any
Depends:  gperf, libgmp-dev,  libpoly-dev (>= 1.4), ${shlibs:Depends}, ${misc:Depends}
Description: Yices SMT Solver
 SRI International's Satisfiability Modulo Theory Solver.
 .
 The package contains several variants of the Yices 2 SMT
 solver that support different input languages, including
 SMT-LIB and the Yices language.

Package: yices2-dev
Section: libdevel
Architecture: any
Depends: yices2,  libyices2.6 (= ${binary:Version}), ${misc:Depends}, libgmp-dev
Description: Yices SMT Solver API Support
 SRI International's Satisfiability Modulo Theory Solver.
 .
 Development headers for the Yices API.


Package: yices2-dbg
Section: debug
Priority: extra
Architecture: any
Depends: yices2, libyices2.6 (= ${binary:Version}), ${misc:Depends}
Provides: yices2-dbg
Description: Yices SMT Solver
 SRI International's Satisfiability Modulo Theory Solver.
 .
 Debugging symbols for Yices 2.
